/* FourWays - a BeOS imput_server add-in enabling gesture recognition
 *
 * FourWaysFilter.cpp
 * 
 * Copyright (C) 2001 Stefan Werner (stefan@keindesign.de)
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <InputServerFilter.h>
#include <Point.h>
#include <Rect.h>
#include <Locker.h>
#include <SupportDefs.h>
#include <OS.h>
#include <View.h>

class FourWaysFilter : public BInputServerFilter
{
	public:
		FourWaysFilter();
		virtual ~FourWaysFilter();
		virtual filter_result Filter(BMessage *message, BList *outList);
		virtual status_t InitCheck();
		virtual uint32 KeyFromSequence (char *sequence);
		
	private:
		BMessenger *FindWindow(BPoint pos);
		void PutWinToBack();
		void BringToFront();
		void MoveWin();
		void SetWinWorkspaces(int32 ws);
				
		BMessenger *mWinMsgr;
		int32 mWinToken;
		BRect mWinFrame;
		bool mValidFrame;
		uint32 mWinLook;
		bool mValidLook;
		int32 mWinWorkspaceMask;
		int32 mOldWorkspace;
		uint32 mWinFlags;
		bool mIsFrontMost;
		bool mIsBackMost;
		
		char *remember;
		BMessage *tempMessage;
		bool validClick;
		bigtime_t downTime, upTime;
		BMessenger *FWDevice;
		
		bool mIsMoving;
		
		BPoint mMousePos;
		
		float mRateCounter;
		float mRateCeil;
		
		int32 buttons;
		int32 modifiers;
		
		BPoint oldPos;
		int32 oldWorkspace;
		
		status_t init;
		
		//Preferences prefs;
		thread_id updateThread;
		
		enum {LEFT=1, TOP=2, RIGHT=4, BOTTOM=8};
		int32 mResizingDirection;
};
